Index: /trunk/LMDZ.GENERIC/libf/phystd/planete.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/planete.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/planete.h	(revision 253)
@@ -1,15 +1,15 @@
-c-----------------------------------------------------------------------
-c INCLUDE planet.h
+!-----------------------------------------------------------------------
+! INCLUDE planet.h
 
-      COMMON/planet/aphelie,periheli,year_day,peri_day,
-     $       obliquit,nres,
-     $       z0,lmixmin,emin_turb,coefvis,coefir,
-     $       timeperi,e_elips,p_elips,unitastr
+      COMMON/planet/apoastr,periastr,year_day,peri_day,                 &
+     &       obliquit,nres,                                             &
+     &       z0,lmixmin,emin_turb,coefvis,coefir,                       &
+     &       timeperi,e_elips,p_elips,unitastr           
 
-      REAL aphelie,periheli,year_day,peri_day,
-     $     obliquit,nres,
-     $     z0,lmixmin,emin_turb,coefvis,coefir,
-     $       timeperi,e_elips,p_elips,unitastr
+      real apoastr,periastr,year_day,peri_day,                          &
+     &     obliquit,nres,                                               &
+     &     z0,lmixmin,emin_turb,coefvis,coefir,                         &
+     &       timeperi,e_elips,p_elips,unitastr     
       
 
-c-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/profile.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/profile.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/profile.F	(revision 253)
@@ -4,5 +4,5 @@
       IMPLICIT NONE
 c=======================================================================
-c     Subroutine utilisee dans le modele 1-D  "testphys1d"
+c     Subroutine utilisee dans "rcm1d"
 c     pour l'initialisation du profil atmospherique
 c=======================================================================
Index: /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 253)
@@ -64,5 +64,5 @@
 !     values manually before compiling, each time you want to change the
 !     dataset.
-
+ 
       integer, parameter :: L_NGAUSS  = 17
 
@@ -70,8 +70,26 @@
       integer, parameter :: L_NTREF   = 7
       integer, parameter :: L_REFVAR  = 7   ! earth / earlymars
+      ! CO2_H2Ovar / N2OCO2rich_H2Ovar / N2OCO2poor_H2Ovar
+!       integer, parameter :: L_REFVAR = 4    ! N2_CH4
+
+!      integer, parameter :: L_NPREF   = 8
+!      integer, parameter :: L_NTREF   = 5
+!      integer, parameter :: L_REFVAR  = 1   ! therm_test2
+
+!      integer, parameter :: L_NPREF   = 12
+!      integer, parameter :: L_NTREF   = 20
+!      integer, parameter :: L_REFVAR  = 1   ! null (for H2 etc.)
+
+!      integer, parameter :: L_NPREF   = 10
+!      integer, parameter :: L_NTREF   = 5
+!      integer, parameter :: L_REFVAR  = 7   ! N2_CO2var
 
 !      integer, parameter :: L_NPREF   = 8
 !      integer, parameter :: L_NTREF   = 6
 !      integer, parameter :: L_REFVAR  = 1   ! pureCO2
+
+!      integer, parameter :: L_NPREF   = 7
+!      integer, parameter :: L_NTREF   = 5
+!      integer, parameter :: L_REFVAR  = 1   ! degraded_pure
 
 !      integer, parameter :: L_NPREF   = 9
@@ -84,10 +102,14 @@
       integer, parameter :: L_PINT    = (L_NPREF-1)*5+1
       integer, parameter :: NAERKIND  = 2
-      integer, parameter :: L_TAUMAX  = 35
+      real,    parameter :: L_TAUMAX  = 35
+      !integer, parameter :: L_TAUMAX  = 35
+      !integer, parameter :: L_TAUMAX  = 40
 
       ! For Planck function integration: 
       ! equivalent temperatures are 1/10 of these values
       integer, parameter :: NTstar = 500
-      integer, parameter :: NTstop = 4000
+!      integer, parameter :: NTstop = 9000 ! for hotstuff runs
+      integer, parameter :: NTstop = 6000 ! for GJ581d / earlymars runs
+!      integer, parameter :: NTstop = 10000 ! for H2 warming runs
 
 ! Maximum number of grain size classes
Index: /trunk/LMDZ.GENERIC/libf/phystd/rain.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/rain.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/rain.F90	(revision 253)
@@ -1,4 +1,4 @@
-
 subroutine rain(ptimestep,pplev,pplay,t,pdt,pq,pdq,d_t,dqrain,dqsrain,dqssnow,rneb)
+
 
   use watercommon_h, only: To, RLVTT, RCPD, RCPV, RV, RVTMP2
@@ -39,5 +39,6 @@
       REAL pplev(ngridmx,nlayermx+1)    ! inter-layer pressure
       REAL pplay(ngridmx,nlayermx)      ! mid-layer pressure
-      REAL t(ngridmx,nlayermx)          ! temperature (K)
+      REAL t(ngridmx,nlayermx)          ! input temperature (K)
+      REAL zt(ngridmx,nlayermx)         ! working temperature (K)
       REAL ql(ngridmx,nlayermx)         ! liquid water (Kg/Kg)
       REAL q(ngridmx,nlayermx)          ! specific humidity (Kg/Kg)
@@ -50,7 +51,7 @@
       PARAMETER (seuil_neb=0.001)
 
-      REAL ct                           ! Inverse of cloud precipitation time
+!      REAL ct                           ! Inverse of cloud precipitation time
 !      PARAMETER (ct=1./1800.)
-      PARAMETER (ct=1./1849.479)
+!      PARAMETER (ct=1./1849.479)
 
       REAL cl                           ! Precipitation threshold
@@ -92,5 +93,7 @@
       real tnext(ngridmx,nlayermx)
 
-      REAL l2c(ngridmx,nlayermx)
+      real l2c(ngridmx,nlayermx)
+      real dWtot
+
 
 !     Indices of water vapour and water ice tracers
@@ -118,13 +121,12 @@
          PRINT*, 'in rain.F, evap_prec=', evap_prec
 
-         print*,ptimestep
-         print*,1./ct
-
-         if(.not.simple)then
-            IF (ABS(ptimestep-1./ct).GT.0.001) THEN
-               PRINT*, 'Must talk to Laurent Li!!!'
-               call abort
-            ENDIF
-         endif
+         !print*,ptimestep
+         !print*,1./ct
+         !if(.not.simple)then
+         !   IF (ABS(ptimestep-1./ct).GT.0.001) THEN
+         !      PRINT*, 'Must talk to Laurent Li!!!'
+         !      call abort
+         !   ENDIF
+         !endif
 
          firstcall = .false.
@@ -135,6 +137,10 @@
       DO i = 1, ngridmx
 
-         q(i,k)    = pq(i,k,i_vap)!+pdq(i,k,i_vap)
-         ql(i,k)   = pq(i,k,i_ice)!+pdq(i,k,i_ice)
+	 zt(i,k)   = t(i,k)+pdt(i,k)*ptimestep ! a big fat bug was here
+         q(i,k)    = pq(i,k,i_vap)+pdq(i,k,i_vap)*ptimestep
+         ql(i,k)   = pq(i,k,i_ice)+pdq(i,k,i_ice)*ptimestep
+
+         !q(i,k)    = pq(i,k,i_vap)!+pdq(i,k,i_vap)
+         !ql(i,k)   = pq(i,k,i_ice)!+pdq(i,k,i_ice)
 
          if(q(i,k).lt.0.)then ! if this is not done, we don't conserve water
@@ -167,14 +173,15 @@
       DO k = 1, nlayermx
          DO i = 1, ngridmx
-            ttemp = t(i,k) 
+            ttemp = zt(i,k) 
             ptemp = pplay(i,k)
-            call watersat_2(ttemp,ptemp,zqs(i,k))
+            call watersat(ttemp,ptemp,zqs(i,k))
          ENDDO
       ENDDO
 
-      ! get column / layer conversion factor (+ptimstep)
+      ! get column / layer conversion factor
       DO k = 1, nlayermx
          DO i = 1, ngridmx
-            l2c(i,k)=(pplev(i,k)-pplev(i,k+1))/(g*ptimestep)
+            !l2c(i,k)=(pplev(i,k)-pplev(i,k+1))/(g*ptimestep)
+            l2c(i,k)=(pplev(i,k)-pplev(i,k+1))/g
          ENDDO
       ENDDO
@@ -189,16 +196,26 @@
             DO i = 1, ngridmx
                IF (zrfl(i) .GT.0.) THEN
+
+                  zqev     = MAX (0.0, (zqs(i,k)-q(i,k)))/ptimestep! BC modif here
+                  zqevt    = 2.0e-5*(1.0-q(i,k)/zqs(i,k))    &
+                       *sqrt(zrfl(i))*l2c(i,k)/pplay(i,k)*zt(i,k)*R ! BC modif here
+                  zqevt    = MAX (zqevt, 0.0)
+                  zqev     = MIN (zqev, zqevt)
+                  zqev     = MAX (zqev, 0.0)
+                  zrfln(i) = zrfl(i) - zqev
+		  zrfln(i) = max(zrfln(i),0.0)
+
                   !zqev     = MAX (0.0, (zqs(i,k)-q(i,k))*eeff1 )
                   !zqevt    = (zrfl(i)/l2c(i,k))*eeff2
                   !zqev     = MIN (zqev, zqevt)
                   !zrfln(i) = zrfl(i) - zqev*l2c(i,k)
-
-                  zrfln(i)  = zrfl(i) - 1.5e-5*(1.0-q(i,k)/zqs(i,k))*sqrt(zrfl(i))
-                  zrfln(i)  = min(zrfln(i),zrfl(i))
+                  !zrfln(i)  = zrfl(i) - 1.5e-5*(1.0-q(i,k)/zqs(i,k))*sqrt(zrfl(i))
+                  !zrfln(i)  = min(zrfln(i),zrfl(i))
                   ! this is what is actually written in the manual
 
-                  d_q(i,k) = - (zrfln(i)-zrfl(i))/l2c(i,k)
-                  d_t(i,k) = d_q(i,k) * RLVTT/RCPD/(1.0+RVTMP2*q(i,k))
-                 
+                  d_q(i,k) = - (zrfln(i)-zrfl(i))/l2c(i,k)*ptimestep
+                  !d_t(i,k) = d_q(i,k) * RLVTT/RCPD!/(1.0+RVTMP2*q(i,k)) ! double BC modif here
+                  d_t(i,k) = - d_q(i,k) * RLVTT/RCPD ! was bugged!
+  
                   zrfl(i)  = zrfln(i)
                ENDIF
@@ -214,17 +231,22 @@
 
             DO i = 1, ngridmx
-            ttemp = t(i,k)
-            IF (ttemp .ge. To) THEN
-               lconvert=rainthreshold
-            ELSEIF (ttemp .gt. t_crit) THEN
-               lconvert=rainthreshold*(1.- t_crit/ttemp)
-            ELSE
-               lconvert=0.
-            ENDIF
-
-            IF (ql(i,k).gt.lconvert)THEN ! precipitate!
-               d_ql(i,k) = (lconvert-ql(i,k))/ptimestep             
-               zrfl(i)   = zrfl(i) + max(ql(i,k) - lconvert,0.0)*l2c(i,k)
-            ENDIF 
+               ttemp = zt(i,k)
+               IF (ttemp .ge. To) THEN
+                  lconvert=rainthreshold
+               ELSEIF (ttemp .gt. t_crit) THEN
+                  lconvert=rainthreshold*(1.- t_crit/ttemp)
+                  lconvert=MAX(0.0,lconvert)              
+               ELSE
+                  lconvert=0.
+               ENDIF
+
+
+               IF (ql(i,k).gt.1.e-9) then
+                  zneb(i)  = MAX(rneb(i,k), seuil_neb)
+                  IF ((ql(i,k)/zneb(i)).gt.lconvert)THEN ! precipitate!
+                     d_ql(i,k) = -MAX((ql(i,k)-lconvert),0.0)
+                     zrfl(i)   = zrfl(i) - d_ql(i,k)*l2c(i,k)/ptimestep
+                  ENDIF
+               ENDIF
             ENDDO
 
@@ -234,7 +256,7 @@
                IF (rneb(i,k).GT.0.0) THEN
                   zoliq(i) = ql(i,k)
-                  zrho(i)  = pplay(i,k) / ( t(i,k) * R )
+                  zrho(i)  = pplay(i,k) / ( zt(i,k) * R )
                   zdz(i)   = (pplev(i,k)-pplev(i,k+1)) / (zrho(i)*g)
-                  zfrac(i) = (t(i,k)-ztglace) / (To-ztglace)
+                  zfrac(i) = (zt(i,k)-ztglace) / (To-ztglace)
                   zfrac(i) = MAX(zfrac(i), 0.0)
                   zfrac(i) = MIN(zfrac(i), 1.0)
@@ -246,6 +268,8 @@
                DO i = 1, ngridmx
                   IF (rneb(i,k).GT.0.0) THEN
-                     zchau(i) = ct*ptimestep/FLOAT(ninter) * zoliq(i)      &
+                     zchau(i) = (1./FLOAT(ninter)) * zoliq(i)      &
                           * (1.0-EXP(-(zoliq(i)/zneb(i)/cl)**2)) * zfrac(i)
+                     ! warning: this may give dodgy results for physics calls .ne. 48 per day...
+
                      ! this is the ONLY place where zneb, ct and cl are used
                      zrhol(i) = zrho(i) * zoliq(i) / zneb(i)
@@ -258,5 +282,5 @@
                      ztot(i)  = MIN(MAX(ztot(i),0.0),zoliq(i))
                      zoliq(i) = MAX(zoliq(i)-ztot(i), 0.0)
-                     
+
                   ENDIF
                ENDDO
@@ -266,6 +290,6 @@
             DO i = 1, ngridmx
                IF (rneb(i,k).GT.0.0) THEN
-                  d_ql(i,k) = (zoliq(i) - ql(i,k))/ptimestep
-                  zrfl(i)   = zrfl(i)+ MAX(ql(i,k)-zoliq(i),0.0)*l2c(i,k)
+                  d_ql(i,k) = (zoliq(i) - ql(i,k))!/ptimestep
+                  zrfl(i)   = zrfl(i)+ MAX(ql(i,k)-zoliq(i),0.0)*l2c(i,k)/ptimestep
                ENDIF
             ENDDO
@@ -277,7 +301,13 @@
 !     Rain or snow on the ground
       DO i = 1, ngridmx
+         if(zrfl(i).lt.0.0)then
+            print*,'Droplets of negative rain are falling...'
+            call abort
+         endif
          IF (t(i,1) .LT. To) THEN
             dqssnow(i) = zrfl(i)
+            dqsrain(i) = 0.0
          ELSE
+            dqssnow(i) = 0.0
             dqsrain(i) = zrfl(i) ! liquid water = ice for now
          ENDIF
@@ -295,25 +325,9 @@
                d_t(i,k)          = 0.0
             endif
-            dqrain(i,k,i_ice) = d_ql(i,k)
+            dqrain(i,k,i_ice) = d_ql(i,k)/ptimestep
          
          ENDDO
       ENDDO
 
-!     debugging
-    !  print*,'zrfl=',zrfl
-    !  print*,'dqrain=',dqrain
-    !  print*,'q=',q
-    !  print*,'ql=',ql
-    !  print*,'dql=',d_ql
-    !  DO k = 1, nlayermx
-    !     DO i = 1, ngridmx
-    !        if(ql(i,k).lt.0.0) then
-    !           print*,'below zero!!!!'
-    !           call abort
-    !        endif
-    !     ENDDO
-    !  ENDDO
-
-
       RETURN
     end subroutine rain
